<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<title>DUNE Warm Interface Board: /home/dan/work/DUNE/dune-wib.firmware/trunk/src/DTS/ProtoDUNE_TimingSystem/pdts_synchro.vhd Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">DUNE Warm Interface Board
   </div>
   <div id="projectbrief">Firmware for the DUNE Warm Interface Board (WIB)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="annotated.html"><span>Design&#160;Unit&#160;List</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Variables</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_d5f2f5bed3199c43277086728111e9c9.html">DTS</a></li><li class="navelem"><a class="el" href="dir_90267f26e899dc7372f7f3f7704d6d52.html">ProtoDUNE_TimingSystem</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">pdts_synchro.vhd</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="keyword">-- pdts_synchro</span><span class="keyword"></span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="keyword">--</span><span class="keyword"></span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="keyword">-- Utility synchroniser <span class="vhdlkeyword">register</span> <span class="vhdlkeyword">for</span> Xilinx</span><span class="keyword"></span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="keyword">-- Note that synchronising buses this way <span class="vhdlkeyword">is</span> unsafe - <span class="vhdlkeyword">use</span> proper techniques</span><span class="keyword"></span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="keyword">--</span><span class="keyword"></span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="keyword">-- Dave Newbold, October </span><span class="vhdllogic">2016</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="vhdlkeyword">library </span><span class="keywordflow">IEEE</span>;</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="vhdlkeyword">use </span>IEEE.STD_LOGIC_1164.<span class="vhdlkeyword">ALL</span>;</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="vhdlkeyword">use </span>ieee.numeric_std.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;</div>
<div class="line"><a name="l00012"></a><span class="lineno"><a class="code" href="classpdts__synchro.html">   12</a></span>&#160;<span class="keywordflow">entity </span><a class="code" href="classpdts__synchro.html">pdts_synchro</a> <span class="vhdlkeyword">is</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;    <span class="vhdlkeyword">generic</span><span class="vhdlchar">(</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;        <span class="vhdlchar">N</span><span class="vhdlchar">:</span> <span class="comment">natural</span> <span class="vhdlchar">:=</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;    <span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;    <span class="vhdlkeyword">port</span><span class="vhdlchar">(</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;        <span class="vhdlchar">clk</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;        <span class="vhdlchar">clks</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;        <span class="vhdlchar">d</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">N</span> <span class="vhdlchar">-</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;        <span class="vhdlchar">q</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">N</span> <span class="vhdlchar">-</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    <span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="vhdlkeyword">end</span> <span class="vhdlchar">pdts_synchro</span>;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div>
<div class="line"><a name="l00025"></a><span class="lineno"><a class="code" href="classpdts__synchro_1_1rtl.html">   25</a></span>&#160;<span class="vhdlkeyword">architecture</span> rtl <span class="vhdlkeyword">of</span> <a class="code" href="classpdts__synchro.html">pdts_synchro</a> is</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="vhdlkeyword">signal</span> <span class="vhdlchar">da</span><span class="vhdlchar">,</span> <span class="vhdlchar">db</span><span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">N</span> <span class="vhdlchar">-</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    <span class="vhdlkeyword">attribute</span> <span class="vhdlchar">ASYNC_REG</span><span class="vhdlchar">:</span> <span class="comment">string</span>;</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    <span class="vhdlkeyword">attribute</span> <span class="vhdlchar">ASYNC_REG</span> <span class="vhdlkeyword">of</span> <span class="vhdlchar">db</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">signal</span> <span class="vhdlkeyword">is</span> <span class="keyword">&quot;yes&quot;</span>;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <span class="vhdlkeyword">attribute</span> <span class="vhdlchar">ASYNC_REG</span> <span class="vhdlkeyword">of</span> <span class="vhdlchar">q</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">signal</span> <span class="vhdlkeyword">is</span> <span class="keyword">&quot;yes&quot;</span>;</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="vhdlkeyword">attribute</span> <span class="vhdlchar">SHREG_EXTRACT</span><span class="vhdlchar">:</span> <span class="comment">string</span>;</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="vhdlkeyword">attribute</span> <span class="vhdlchar">SHREG_EXTRACT</span> <span class="vhdlkeyword">of</span> <span class="vhdlchar">db</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">signal</span> <span class="vhdlkeyword">is</span> <span class="keyword">&quot;no&quot;</span>;</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="vhdlkeyword">begin</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="vhdlchar">da</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">d</span> <span class="vhdlkeyword">when</span> <span class="vhdlchar">rising_edge</span><span class="vhdlchar">(</span><span class="vhdlchar">clk</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="vhdlchar">db</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">da</span> <span class="vhdlkeyword">when</span> <span class="vhdlchar">rising_edge</span><span class="vhdlchar">(</span><span class="vhdlchar">clks</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="vhdlchar">q</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">db</span> <span class="vhdlkeyword">when</span> <span class="vhdlchar">rising_edge</span><span class="vhdlchar">(</span><span class="vhdlchar">clks</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    </div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="vhdlkeyword">end</span> <span class="vhdlchar">rtl</span>;</div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed Nov 1 2017 10:40:30 for DUNE Warm Interface Board by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.1
</small></address>
</body>
</html>
